[FFe] mod_http2 is not available in Apache

Bug #1658469 reported by Vivien GUEANT on 2017-01-22
40
This bug affects 5 people
Affects Status Importance Assigned to Milestone
apache2 (Ubuntu)
Low
Nish Aravamudan
Xenial
Undecided
Unassigned
Zesty
Undecided
Unassigned

Bug Description

Feature Freeze justification (multiple):

1) This is an entirely new, opt-in feature, currently not available to users. They would need to enable said feature i order to use it.

2) We intend to examine SRU of this feature to 16.04 (and thus would also need to SRU to 17.10 if we wait until 18.04 to do it.) The change is coming either way :)

3) We want to maximize the exposure/testing of HTTP/2 before 18.04 releases; having it in 17.10 will assist with that.

4) From a practical perspective, this reduces our delta to Debian.

---

mod_http2 for HTTP/2 is not available in folder /etc/apache2/mods-available
(/etc/apache2/mods-available/http2.load does not exist)

HTTP/2 (originally named HTTP/2.0) is the second major version of the HTTP network protocol used by the World Wide Web.

In January 2016 it was decided not to put http/2 in Ubuntu 16.04 LTS because the code is too young and not compatible with a 5 years support: https://lists.ubuntu.com/archives/ubuntu-release/2016-January/003499.html

"Don't build experimental http2 module for LTS:"
=> https://launchpad.net/ubuntu/zesty/+source/apache2/+changelog

Ubuntu 17.04 has a support of 9 months and the http/2 code exists for 2 years. It is no longer necessary to disable http/2.

ChristianEhrhardt (paelzer) wrote :

@Nish - you have the apache2 merge assigned this cycle - what do you think?

Vivien GUEANT (vivienfr) wrote :

The merge from Debian will be ok, because Debian already offers the mod HTTP/2.

Just make sure not to remove HTTP/2, when merging from Debian.

Nish Aravamudan (nacc) wrote :

I'm updating our 17.04 merge right now, I think this makes sense.

Nish Aravamudan (nacc) on 2017-02-10
Changed in apache2 (Ubuntu):
status: New → Fix Committed
importance: Undecided → High
assignee: nobody → Nish Aravamudan (nacc)
Nish Aravamudan (nacc) wrote :

apache2 is now stuck in proposed. This is becuase nghttp2 (src package) is in universe, and so is libnghttp2-14 which apache2 depends on when enabling http2. We would need a MIR to promote nghttp2 and given where we are in the cycle, that seems unlikely to be approved. Additionally, regardless of Debian, upstream apache still considers it experimental: https://httpd.apache.org/docs/2.4/mod/mod_http2.html.

Given all that, I'm much more comfortable aiming for HTTP2 support in 17.10, as anticipatory of 18.04 and will pursue the MIR and needed first thing in that cycle.

Changed in apache2 (Ubuntu):
status: Fix Committed → Triaged
importance: High → Low
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package apache2 - 2.4.25-3ubuntu2

---------------
apache2 (2.4.25-3ubuntu2) zesty; urgency=medium

  * Undrop (LP 1658469):
    - Don't build experimental http2 module for LTS:
      + debian/control: removed libnghttp2-dev Build-Depends (in universe).
      + debian/config-dir/mods-available/http2.load: removed.
      + debian/rules: removed proxy_http2 from configure.
      + debian/apache2.maintscript: remove http2 conffile.

 -- Nishanth Aravamudan <email address hidden> Fri, 10 Feb 2017 08:53:43 -0800

Changed in apache2 (Ubuntu):
status: Triaged → Fix Released
Nish Aravamudan (nacc) on 2017-02-22
Changed in apache2 (Ubuntu):
status: Fix Released → Triaged
Nish Aravamudan (nacc) on 2017-03-01
Changed in apache2 (Ubuntu):
milestone: none → later
Nish Aravamudan (nacc) wrote :

I am uploading the http2-enabled apache2 to a-p, but will need to process the MIR for nghttp2.

Changed in apache2 (Ubuntu):
status: Triaged → Fix Committed
Thomas Ward (teward) wrote :

Just an FYI here, back in Xenial, nghttp2 was NACK'd by the Security Team, and that's why http2 was *disabled* in Xenial+ Apache2.

Before we go uploading HTTP/2 enabled things to Proposed like this, we should probably check if the MIR clears.

Robie Basak (racb) wrote :

18:13 <rbasak> nacc: not sure about bug 1658469
18:13 <ubottu> bug 1658469 in apache2 (Ubuntu) "mod_http2 is not available under Apache 2.4.23 / Ubuntu 17.04 xenial" [Low,Fix committed] https://launchpad.net/bugs/1658469
18:13 <rbasak> nacc: to my knowledge we've never added and then removed things to avoid putting things in an LTS.
18:13 <teward> rbasak: refer to -hardened and my mention about nghttp2
18:13 <rbasak> Yeah I saw that, but nacc wasn't in that channel.
18:14 <teward> yep.
18:14 <teward> nacc: IIRC, the Security team had NACK'd http2 back in Xenial
18:14 <teward> at least nghttp2
18:14 <rbasak> nacc: if it's not good enough for an LTS, it's not good enough for a non-LTS release.
18:14 <teward> (NGINX rolls their own implementation separate from nghttp2)
18:15 -!- knoxy has joined #ubuntu-server

Vivien GUEANT (vivienfr) wrote :

Changes with Apache 2.4.26 : HTTP/2 support no longer tagged as "experimental" but is instead considered fully production ready.
=> http://www.apache.org/dist/httpd/CHANGES_2.4.26

Robie Basak (racb) on 2017-06-19
tags: added: server-next
Nish Aravamudan (nacc) wrote :

Yes, after discussing with others, this (nghttp2) will need to be reviewed for MIR (bug # 1687454) but has been uploaded for Artful.

It will probably not be backported to 16.04 or other releases without further review (as the version declaring HTTP/2 stability is 2.4.26 which is not the version in 16.04, etc.)

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package apache2 - 2.4.27-2ubuntu2

---------------
apache2 (2.4.27-2ubuntu2) artful; urgency=medium

  * Undrop (LP 1658469):
    - Don't build http2 module (nghttp2 still not in main) (LP 1687454)
      + debian/control: removed libnghttp2-dev Build-Depends (in universe).
      + debian/config-dir/mods-available/http2.load: removed.
      + debian/rules: removed proxy_http2 from configure.

 -- Marc Deslauriers <email address hidden> Wed, 02 Aug 2017 13:04:45 -0400

Changed in apache2 (Ubuntu):
status: Fix Committed → Fix Released
Nish Aravamudan (nacc) on 2017-08-03
Changed in apache2 (Ubuntu):
status: Fix Released → Triaged
Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in apache2 (Ubuntu Xenial):
status: New → Confirmed
Changed in apache2 (Ubuntu Zesty):
status: New → Confirmed
Vivien GUEANT (vivienfr) wrote :

Is it possible to affect the bug for Ubuntu 17.10 Artful Aardvark ?

I think it is possible to close the bug for Ubuntu 17.04 Zesty Zapus and Ubuntu 16.04 Xenial Xerus who do not have apache 2.4.27

Adedayo (adedayo) wrote :

Hello i am new to ubuntu curently i am running ubuntu 17.04 and i have been trying to install apache2 and php 5.6 mysql server and phpmyadmin and i have been finding it dificult to install

Failed to restart apache2.service: Unit apache2.service is masked.
is what i get anaytime i try to start my apache2

ChristianEhrhardt (paelzer) wrote :

Hi Adedayo this seems to be an unrelated case, please open a new bug and add some more info on your setup - consider using apport to do so semi-automatically.

ChristianEhrhardt (paelzer) wrote :

MIR in 1687454 ongoing (just got an security ack) but we might be too late into the feature freeze now?
@Nacc/Marc what is your plan of action on this 17.10/18.04 ?

ChristianEhrhardt (paelzer) wrote :

Keeping Development open (waiting for statements on 17.10/18.04) but denying the Xenial/Zesty tasks according to c#10

Changed in apache2 (Ubuntu Zesty):
status: Confirmed → Won't Fix
Changed in apache2 (Ubuntu Xenial):
status: Confirmed → Won't Fix
Nish Aravamudan (nacc) on 2017-09-19
summary: - mod_http2 is not available under Apache 2.4.23 / Ubuntu 17.04 xenial
+ mod_http2 is not available in Apache
summary: - mod_http2 is not available in Apache
+ [FFe] mod_http2 is not available in Apache
description: updated
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers